$(document).ready(function() {

	/* Helper function for writing to firebug console if available */
	function logit(msg) {
		if(window.console && window.console.firebug){
			console.log(msg);
		}
	};
	
	var aSelected;
	
	$('#extreme').selectedIndex = 0;
	$('#abundant').selectedIndex = 2;
	
	logit("elemental_main.js Loaded");
	
	var aFamilyColors = [ "#e6f9e6", "#ffe8d9", "#e1e8f0", "#f9e6e6", "#ecffff", "#ece0ec", "#ffffe0", "#ffffe0", "#ffe6f3", "#fff"] ;
		
	var sL = "Lithium adds a red color to fireworks.";
	var sC = "Used in one of a firework's prime components: black powder.";
	var sNa = "Sodium, the fourth most abundant element on Earth, helps produce the gold and yellow colors in fireworks.";
	var sMg = "Magnesium contributes to creating bright white flames in fireworks.";
	var sAl = "Helps produce silver and white sparks and flames, such as those produced by sparklers.";
	var sP = "This combustible element can be found in four forms, some of which ignite spontaneously in air, making them very hazardous with which to work.";
	var sS = "Odorless and pale yellow, sulfur helps fuel fireworks.";
	var sK = "Potassium, found in soil and in man-made fertilizers, is a combustible element that helps oxidize firework mixtures.";
	var sCa = "Silvery in color, calcium can help deepen the colors produced by other elements in a firework mixture.";
	var sTi = "Titanium helps produce sparks.";
	var sFe = "Found in large quantities in the Earth's crust, iron helps produce sparks.";
	var sCu = "A good conductor of heat and electricity, copper helps to create blue colors seen in fireworks.";
	var sZn = "A bluish-white metal, zinc contributes to creating smoke clouds, among other effects.";
	var sSr = "Strontium, which does not occur naturally, brings the red color to fireworks, as well as helping to stabilize and oxidize firework mixtures.";
	var sSb = "Although a poor conductor of heat and electricity, this element helps create glitter effects.";
	var sBa = "Only found naturally in combination with other elements, barium is used to create green colors in fireworks, and can also help stabilize other volatile elements.";
	
	var aPyro =       [ ["", "", "", ""], [3,sL] ,[ 6,sC],[ 11,sNa],[12,sMg],[13,sAl],[15,sP],[16,sS],[19,sK],[20,sCa],[22,sTi],[26,sFe],[29,sCu],[30,sZn],[38,sSr],[51,sSb],[56,sBa] ];	
	var aBody =       [ ["Abundance in human body:", "%", "is the", "most abundant element in the human body."], [8,61], [6,23], [1,10], [7,2.6], [20,1.4], [15,1.1], [16,0.2], [19,0.2], [11,0.14], [17,0.12] ];	
	var aEarthCrust = [ ["Abundance in the Earth's crust:", "%", "is the", "most abundant element in the Earth's crust."], [8,46],[14,27],[13,8.1],[26,6.3],[20,5],[12,2.9],[11,2.3],[19,1.5],[22,0.66],[ 6,0.18] ];
	var aOcean =      [ ["Abundance in the ocean:", "%", "is the", "most abundant element in the ocean."], [8,86],[ 1,11],[17,2],[11,1.1],[12,0.13],[16,0.093],[19,0.042],[35,0.0067],[ 6,0.0028],[38,0.00081] ];
	var aSun =        [ ["Abundance in the Sun:", "%", "is the", "most abundant element in the Sun."], [1,75],[ 2,23],[ 8,0.9],[ 6,0.3],[ 7,0.1],[10,0.1],[26,0.1],[14,0.09],[12,0.07],[16,0.04] ];
	var aUniverse =   [ ["Abundance in the universe:", "%", "is the", "most abundant element in the universe."], [1,75],[ 2,23],[ 8,1],[ 6,0.5],[10,0.13],[26,0.11],[ 7,0.1],[14,0.07],[12,0.06],[16,0.05] ];

	var aLowMelt =    [ ["Melting Point:", " &#176;C", "has the", "lowest melting point."], [1,-259.14], [ 10,-248.59],[ 9,-219.6],[ 8,-218.3],[ 7,-210.1],[ 18,-189.3],[ 36,-157.36],[ 54,-111.8],[ 17,-101.5],[ 86,-71] ];
	var aHighMelt =   [ ["Melting Point:", " &#176;C", "has the", "highest melting point."], [6,3550], [ 74,3422],[ 75,3186],[ 76,3033], [73, 3017], [42,2623 ],[41,2477 ], [77,2466],[ 44,2334], [72,2233] ];
	var aLowDensity = [ ["Density:", " g/liter", "has the", "lowest density."], [1,0.0899],[ 2,0.1785],[ 10,0.9],[ 7,1.251],[ 8,1.429],[ 9,1.696],[ 18,1.784],[ 17,3.214],[ 36,3.75],[ 54,5.9] ];
	var aHighDensity =[ ["Density:", " g/cm<sup>3</sup>", "has the", "highest density."], [77,22.65],[ 76,22.61],[ 78,21.09],[ 75,21.02],[ 93,20.45],[ 94,19.816],[ 79,19.3],[ 74,19.25],[ 92,19.05],[ 73,16.65] ];
	var aLowBoil =    [ ["Boiling Point:", " &#176;C", "has the", "lowest boiling point."],[ 2,-268.93],[ 1,-252.87],[ 10,-246.08],[ 7,-195.79],[ 9,-188.12],[ 18,-185.8],[ 8,-182.9],[ 36,-153.22],[ 54,-108],[ 86,-61.7 ] ];
	var aHighBoil =   [ ["Boiling Point:", " &#176;C", "has the", "highest boiling point."], [75,5596],[ 74,5555],[ 73,5458],[ 90,5012],[ 41,4820],[ 42,4744],[ 72,4639],[ 77,4603],[ 40,4428],[ 43,4409] ];
	
	var bPyro = false;
	
	var aSuffix = ["", "", "nd", "rd", "th", "th", "th", "th", "th", "th", "th", "th","th","th","th","th","th"];
	
	var aFamiliesTitle =  [ 
	"Alkali metals", 
	"Alkaline earth metals", 
	"Transition metals" , 
	"Metalloids", 
	"Lanthanides", 
	"Actinides", 
	"Nonmetals", 
	"Halogens", 
	"Noble gases",
	"Unknown"];
	
	var aFamiliesText =   [ "Alkali metals have a single electron in their outermost energy level, so they bond readily with other elements. They are typically soft enough to slice with a knife and are good conductors of heat and electricity.", 
	
	"With two electrons in their outermost energy level, alkaline earth metals have high melting points and bond almost as readily as the alkali metals.", "Like other metals, transition metals are good conductors of heat and electricity. When they combine with other elements, they often produce brightly colored compounds. Many familiar industrial metals are transition metals.", 
	
	"Metalloids have some of the properties of non-metals and some of the properties of metals. They often make good semiconductors.", 
	
	"These lustrous, malleable metals are found dispersed throughout Earth's crust, and many are critical for the manufacturing of modern electronics.", "The actinides are all radioactive. Most actinides decay quickly and are not found in nature, though they can be synthesized in the lab.", 
	
	"Nonmetals are typically poor conductors of heat and electricity. They are brittle and melt at relatively low temperature.", 
		
	"Halogens are a class of nonmetals with seven out of a maximum of eight electrons in their outer shell. They are highly reactive.", 

	"Noble gases have a full set of eight electrons in their outer shell, making them very stable and unlikely to combine with other elements. They are all gases at room temperature."];
		
	var slugAsterix = [,,,,"*","**",,,,];
	var slugExplain = "These are shown in a row below since their properties are similar.";

	
	$('#abundantElements').change(function() {
	
		var sID = $('#abundantElements option:selected').val()
		
		logit( sID ); 
		
		filterUpdate( sID );
		
		var selObj = document.getElementById('extreme');
		
		// logit( "The selected object of extreme = " + selObj.selectedIndex  ); 
		
		selObj.selectedIndex = 0;
		
		
	});
	
	$('#extremeElements').change(function() {
	
		var sID = $('#extremeElements option:selected').val()
		
		logit( sID ); 
		
		var selObj = document.getElementById('abundant');
		
		// logit( "The selected object of extreme = " + selObj.selectedIndex  ); 
		
		selObj.selectedIndex = 0;

		filterUpdate( sID );
		
		
	});
	
	
	function filterUpdate(sID) {
	
		logit("filterUpdate.EnterFunction with sID = " + sID);
				
		$('.periodic-element-chart').removeClass('filter-hit');	
		
		bPyro = ( sID == "PY" );
		
		switch (sID) {
		
			case "PY":
			
				aSelected = aPyro;
				break;
				
			case "HB":
			
				aSelected = aBody;
				break;				
				
			case "EC":
			
				aSelected = aEarthCrust;
				break;				
				
			case "OC":
			
				aSelected = aOcean;
				break;				
				
			case "SU":
			
				aSelected = aSun;
				break;				
				
			case "UN":
			
				aSelected = aUniverse;
				break;				
				
			case "LM":
			
				aSelected = aLowMelt;
				break;				
				
			case "HM":
			
				aSelected = aHighMelt;
				break;				
				
			case "LD":
			
				aSelected = aLowDensity;
				break;				
				
			case "HD":
			
				aSelected = aHighDensity;
				break;				
				
			case "LB":
			
				aSelected = aLowBoil;
				break;
				
			case "UB":
			
				aSelected = aHighBoil;
				break;
				
			default:
			
				aSelected = "";
				logit("no array found that corresponds to this filter ID");
				break;
		
		}
		
		if ( aSelected != "" && aSelected != null ) {
		
			logit("filterUpdate.array element 1 of selected array = " + aSelected[1]);
			
			for (var i=1; i<aSelected.length; i++) {
			
				$("#e"+aSelected[i][0]).addClass('filter-hit');
			}	
			
			// now prefill the filter-specific phrases in the popup
			
			$('#tooltip2 #periodic-popup-phrase-start').html(aSelected[0][0]);
			$('#tooltip2 #periodic-popup-units').html(aSelected[0][1]);
			$('#tooltip2 #periodic-popup-qualifier').html(aSelected[0][2]);
			$('#tooltip2 #periodic-popup-phrase-end').html(aSelected[0][3]);

		} else {
		
			// do nothing
		
		}
	
	};
	
	filterUpdate("PY");
	
	
	// stuff for tooltips below:
	
		$(".credits-popup").tooltip({
	
		position: "top left", 
		relative: "true", 
		offset: [-1 , 35], 
		delay: 50,
		predelay: 100
	});
		
	$("ul.families-popup li").tooltip({
	
		tip: "#tooltip1",
		position: "top right", 
		relative: "true", 
		offset: [-10 , -135], 
		delay: 50,
		predelay: 100,		
		
		onBeforeShow: function() {
		
			var currentId = this.getTrigger().attr('id').split("",2)[1];
			
			logit("the rolled over family id = " + currentId);

			if ( currentId != "" || currentId != null ) {
			
				$('#tooltip1 .family-text .title').html(aFamiliesTitle[currentId]+":");
				$('#tooltip1 .family-text .description').html(aFamiliesText[currentId]);
				$('#tooltip1 .family-text .slug-explain').html("");			
			};
			
			this.getTrigger().addClass("family-active");			
			
		},
		
		onHide: function() {		
			
			this.getTrigger().removeClass("family-active");						
		}		
	});
	
	$(".periodic-element-chart-slug").tooltip({
	
		tip: "#tooltip1",
		position: "top right", 
		offset: [-20 , -50], 
		delay: 10,
		predelay: 100,		
		
		onBeforeShow: function() {
		
			var currentId = this.getTrigger().attr('id').split("",2)[1];
			
			logit("the rolled over family id = " + currentId);

			if ( currentId != "" || currentId != null ) {
			
				$('#tooltip1 .family-text .title').html(aFamiliesTitle[currentId]+":");
				$('#tooltip1 .family-text .description').html(aFamiliesText[currentId]);
				$('#tooltip1 .family-text .slug-explain').html("<br />" + slugAsterix[currentId] + slugExplain);
			
			};			
			this.getTrigger().addClass("family-active");
		},
		
		onHide: function() {		
			
			this.getTrigger().removeClass("family-active");
		}		
	});

	
	$(".periodic-element-chart").tooltip({
	
		tip: "#tooltip2",
		position: "top right",  
		offset: [-20 , -42], 
		delay: 10,
		predelay: 100,
		
		onBeforeShow: function() {
		
		
			var currentId = this.getTrigger().attr('id');
			
			logit("the rolled over element id = " + currentId);

			var ncurrentId = Number( currentId.split("e")[1] );
			
			var abbr = $('#'+currentId+' .periodic-element-chart-abbr').html();

			var nmass = $('#' + currentId + ' ul li:nth-child(3)').html();
  			
			var sname = $('#' + currentId + ' ul li:nth-child(4)').html();
			
			var ifamily = $('#' + currentId + ' ul li:nth-child(5)').html();
			
			if ( ncurrentId ) {
			
				//logit("the rolled over family id = " + ncurrentId );
				
				$('#tooltip2 .periodic-element-pu-number').html(ncurrentId);
				$('#tooltip2 .periodic-element-pu-abbr').html(abbr);
				$('#tooltip2 .periodic-element-pu-mass').html(nmass);
				$('#tooltip2 .periodic-element-pu-name').html(sname);
				$('#tooltip2 #periodic-element-pu-family').html(aFamiliesTitle[ifamily]);
				
				logit("the number of classes in the popup = " + $('#tooltip2 .periodic-element-pu-gfx')  );
				
				var colorFam = aFamilyColors[ifamily];
				
				
				//$('#tooltip2 .periodic-element-pu-gfx').each().removeClass("family\\S*");
				
				//logit("does the popup have a family class on it? = " + $('#tooltip2 .periodic-element-pu-gfx').hasClass("family\\S*")  );
				
				//logit("does the popup have alkali class on it? = " + $('#tooltip2 .periodic-element-pu-gfx').hasClass("family-alkali")  );
				
				
			//	$('#tooltip2 .periodic-element-pu-gfx').addClass("family-alkali");
			
				
				
				$('#tooltip2 .periodic-element-pu-gfx').css('background-color', colorFam);

				if (bPyro) {
				
					var theindex = 1
				
					for (var i=1; i<aSelected.length; i++) {
					
						if ( aSelected[i][0] == ncurrentId ) {
						
							theindex = i;
						}
					}	

					$('#tooltip2 #periodic-popup-phrase-start').html(aSelected[theindex][1]);
					$('#tooltip2 #periodic-popup-rank').html("");					
					$('#tooltip2 #periodic-popup-rank-suffix').html("");
					$('#tooltip2 #periodic-popup-value').html("");	
					$('#tooltip2 #periodic-element-pu-name-detail').html("");	
					
					
				} else if ( aSelected != "" ) {				
					
					var rank = 4;
					
					for (var i=1; i<aSelected.length; i++) {
					
						if ( aSelected[i][0] == ncurrentId ) {
						
							rank = i;
						}
					}	
					
					if ( rank == 1) {
						$('#tooltip2 #periodic-popup-rank').html("");
					} else {
						$('#tooltip2 #periodic-popup-rank').html(rank);
					}
					
					$('#tooltip2 #periodic-popup-rank-suffix').html(aSuffix[rank]);
					$('#tooltip2 #periodic-popup-value').html(aSelected[rank][1]);
				}
				
				this.getTrigger().addClass("element-active");
				
				//logit("does the element have a filter on it? = " + $('#' + currentId).hasClass('filter-hit') );
				
				if ( $('#' + currentId).hasClass('filter-hit') )
				
				{ $('#tooltip2 #filter-info').removeClass('hide-info'); }
				
				else { $('#tooltip2 #filter-info').addClass('hide-info'); };
				
			};
			
			
		},
		
		onHide: function() {
		
			
			this.getTrigger().removeClass("element-active");
			
			
		}
		
		
		
	}).dynamic();
	
	
});